(ns com.aurellem.gb.badges
  (:use (com.aurellem.gb gb-driver util constants))
  (:use (com.aurellem.world practice))
  (:import [com.aurellem.gb.gb_driver SaveState]))

(def badges '(:boulder :cascade :thunder :marsh :rainbow :soul :volcano
     :earth))

(defn get-badges
  "Returns a list of the current badges held by the player."
  ([state]
    ((fn this [coll n]
      (cond (zero? n) '()
            (zero? (rem n 2)) (recur (pop coll) (int (/ n 2)))
            :else (cons (peek coll) (this (pop coll) (int (/ n
                                                             2))))))
     badges
     (aget (memory state) 0xD355)
     ))
  ([] (get-badges @current-state)))

(defn set-badges
  "Sets the badges held by the player. badge-list may contain :boulder
:cascade :thunder :marsh :rainbow :soul :volcano."
  ([state badge-list]
     (let [has-badge (set badge-list)]
       (->>
        ((fn [n coll]
           (cond
             (empty? coll) n
             (has-badge (peek coll)) (recur (inc(* 2 n)) (pop coll))
             :else (recur (* 2 n) (pop coll))))
      
         0
         (vec badges))
        (set-memory state 0xD355))))
     
    
  ([badge-list] (set-badges @current-state badge-list)))


  

    

  
  ;; (let [mem (aget (memory state) 0xD354)]
  ;;   ((fn this [coll n]
  ;;     (cond (zero? n) '()
  ;;           (zero? (rem n 2)) (recur (pop coll) (int (/ n 2)))
  ;;           :else (cons (peek coll) (this (pop coll) (int (/ n
  ;;                                                            2))))))
  ;;    badges
  ;;    (aget (memory state) 0xD354)
  ;;    )))
  